﻿namespace TabsStudioSync
{
    class CommandsImpl
    {
        public CommandsImpl(TabsStudioExt.ITabsStudioEngine engine_, EnvDTE80.DTE2 dte)
        {
            engine = engine_;
            solutionExplorer = new SolutionExplorer(dte);
        }

        public void SyncTab()
        {
            TabsStudioExt.Tab tab = FindSelectedTab();
            if (tab != null)
                SyncTab(tab);
        }

        public void SyncExt()
        {
            TabsStudioExt.TabExtension ext = FindSelectedExt();
            if (ext != null)
                SyncExt(ext);
        }

        public void SyncTab(TabsStudioExt.Tab tab)
        {
            try
            {
                System.Collections.Generic.List<EnvDTE.Document> docs = new System.Collections.Generic.List<EnvDTE.Document>();
                foreach (TabsStudioExt.TabExtension tabExtension in tab.TabExtensions)
                    docs.Add(tabExtension.Window.Document);
                solutionExplorer.SyncDocuments(docs);
            }
            catch (System.Exception)
            {
            }
        }

        public void SyncExt(TabsStudioExt.TabExtension ext)
        {
            try
            {
                solutionExplorer.SyncDocument(ext.Window.Document);
            }
            catch (System.Exception)
            {
            }
        }

        private TabsStudioExt.Tabs FindSelectedTabs()
        {
            foreach (TabsStudioExt.Tabs tabs in engine.GetTabs())
            {
                if (tabs.IsGroupSelected)
                    return tabs;
            }
            return null;
        }

        private TabsStudioExt.Tab FindSelectedTab()
        {
            TabsStudioExt.Tabs tabs = FindSelectedTabs();
            if (tabs != null)
            {
                foreach (TabsStudioExt.Tab tab in tabs.TabList)
                {
                    if (tab.IsTabSelected)
                        return tab;
                }
            }
            return null;
        }

        private TabsStudioExt.TabExtension FindSelectedExt()
        {
            TabsStudioExt.Tab tab = FindSelectedTab();
            if (tab != null)
            {
                foreach (TabsStudioExt.TabExtension tabExtension in tab.TabExtensions)
                {
                    if (tabExtension.IsExtensionActive)
                        return tabExtension;
                }
            }
            return null;
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private SolutionExplorer solutionExplorer;
    }
}
